/* File generated from interface.idl */

#include <stddef.h>
#include <string.h>
#include <caml/mlvalues.h>
#include <caml/memory.h>
#include <caml/alloc.h>
#include <caml/fail.h>
#include <caml/callback.h>
#ifdef Custom_tag
#include <caml/custom.h>
#include <caml/bigarray.h>
#endif
#include <caml/camlidlruntime.h>


#include "interface.h"

void camlidl_ml2c_interface_solver(value _v1, solver * _c2, camlidl_ctx _ctx)
{
  *_c2 = *((solver *) Bp_val(_v1));
}

value camlidl_c2ml_interface_solver(solver * _c2, camlidl_ctx _ctx)
{
value _v1;
  _v1 = camlidl_alloc((sizeof(solver) + sizeof(value) - 1) / sizeof(value), Abstract_tag);
  *((solver *) Bp_val(_v1)) = *_c2;
  return _v1;
}

value camlidl_interface_get_solver(value _unit)
{
  solver _res;
  value _vres;

  struct camlidl_ctx_struct _ctxs = { CAMLIDL_TRANSIENT, NULL };
  camlidl_ctx _ctx = &_ctxs;
  _res = get_solver();
  _vres = camlidl_c2ml_interface_solver(&_res, _ctx);
  camlidl_free(_ctx);
  return _vres;
}

value camlidl_interface_delete_solver(
	value _v_s)
{
  solver s; /*in*/
  struct camlidl_ctx_struct _ctxs = { CAMLIDL_TRANSIENT, NULL };
  camlidl_ctx _ctx = &_ctxs;
  camlidl_ml2c_interface_solver(_v_s, &s, _ctx);
  delete_solver(s);
  camlidl_free(_ctx);
  return Val_unit;
}

value camlidl_interface_add(
	value _v_s,
	value _v_clause,
	value _v_len)
{
  solver s; /*in*/
  int *clause; /*in*/
  int len; /*in*/
  mlsize_t _c1;
  mlsize_t _c2;
  value _v3;
  struct camlidl_ctx_struct _ctxs = { CAMLIDL_TRANSIENT, NULL };
  camlidl_ctx _ctx = &_ctxs;
  camlidl_ml2c_interface_solver(_v_s, &s, _ctx);
  _c1 = Wosize_val(_v_clause);
  clause = camlidl_malloc(_c1 * sizeof(int ), _ctx);
  for (_c2 = 0; _c2 < _c1; _c2++) {
    _v3 = Field(_v_clause, _c2);
    clause[_c2] = Int_val(_v3);
  }
  len = Int_val(_v_len);
  add(s, clause, len);
  camlidl_free(_ctx);
  return Val_unit;
}

value camlidl_interface_is_satisfiable_aux(
	value _v_s)
{
  solver s; /*in*/
  int _res;
  value _vres;

  struct camlidl_ctx_struct _ctxs = { CAMLIDL_TRANSIENT, NULL };
  camlidl_ctx _ctx = &_ctxs;
  camlidl_ml2c_interface_solver(_v_s, &s, _ctx);
  _res = is_satisfiable_aux(s);
  _vres = Val_int(_res);
  camlidl_free(_ctx);
  return _vres;
}

value camlidl_interface_is_sat(
	value _v_s)
{
  solver s; /*in*/
  int _res;
  value _vres;

  struct camlidl_ctx_struct _ctxs = { CAMLIDL_TRANSIENT, NULL };
  camlidl_ctx _ctx = &_ctxs;
  camlidl_ml2c_interface_solver(_v_s, &s, _ctx);
  _res = is_sat(s);
  _vres = Val_int(_res);
  camlidl_free(_ctx);
  return _vres;
}

value camlidl_interface_val_of(
	value _v_s,
	value _v_i)
{
  solver s; /*in*/
  int i; /*in*/
  int _res;
  value _vres;

  struct camlidl_ctx_struct _ctxs = { CAMLIDL_TRANSIENT, NULL };
  camlidl_ctx _ctx = &_ctxs;
  camlidl_ml2c_interface_solver(_v_s, &s, _ctx);
  i = Int_val(_v_i);
  _res = val_of(s, i);
  _vres = Val_int(_res);
  camlidl_free(_ctx);
  return _vres;
}

