/* File generated from yinterface.idl */

#ifndef _CAMLIDL_YINTERFACE_H
#define _CAMLIDL_YINTERFACE_H

#ifdef __cplusplus
#define _CAMLIDL_EXTERN_C extern "C"
#else
#define _CAMLIDL_EXTERN_C extern
#endif

#ifdef _WIN32
#pragma pack(push,8) /* necessary for COM interfaces */
#endif

typedef void *yices_context;

typedef void *yices_expr;

typedef void *yices_model;

typedef void *yices_type;

typedef void *yices_var_decl;

_CAMLIDL_EXTERN_C yices_context yices_mk_context(void);

_CAMLIDL_EXTERN_C void yices_del_context(/*in*/ yices_context c);

_CAMLIDL_EXTERN_C yices_type yices_mk_type(/*in*/ yices_context ctx, /*in*/ char *name);

_CAMLIDL_EXTERN_C yices_type yices_mk_function_type(/*in*/ yices_context ctx, /*in*/ yices_type *domain, /*in*/ int domain_size, /*in*/ yices_type range);

_CAMLIDL_EXTERN_C yices_var_decl yices_mk_var_decl(/*in*/ yices_context ctx, /*in*/ char *name, /*in*/ yices_type ty);

_CAMLIDL_EXTERN_C yices_expr yices_mk_var_from_decl(/*in*/ yices_context ctx, /*in*/ yices_var_decl d);

_CAMLIDL_EXTERN_C void yices_assert(/*in*/ yices_context c, /*in*/ yices_expr e);

_CAMLIDL_EXTERN_C int yices_check_aux(/*in*/ yices_context c);

_CAMLIDL_EXTERN_C void yices_dump_context(/*in*/ yices_context ctx);

_CAMLIDL_EXTERN_C yices_model yices_get_model(/*in*/ yices_context ctx);

_CAMLIDL_EXTERN_C void yices_display_model(/*in*/ yices_model m);

_CAMLIDL_EXTERN_C int yices_get_int_value(/*in*/ yices_model m, /*in*/ yices_var_decl x, /*in*/ long *val);

_CAMLIDL_EXTERN_C int yices_get_value(/*in*/ yices_model m, /*in*/ yices_var_decl x);

_CAMLIDL_EXTERN_C yices_expr yices_mk_eq(/*in*/ yices_context c, /*in*/ yices_expr e1, /*in*/ yices_expr e2);

_CAMLIDL_EXTERN_C yices_expr yices_mk_ge(/*in*/ yices_context c, /*in*/ yices_expr e1, /*in*/ yices_expr e2);

_CAMLIDL_EXTERN_C yices_expr yices_mk_gt(/*in*/ yices_context c, /*in*/ yices_expr e1, /*in*/ yices_expr e2);

_CAMLIDL_EXTERN_C yices_expr yices_mk_ite(/*in*/ yices_context c, /*in*/ yices_expr i, /*in*/ yices_expr t, /*in*/ yices_expr e);

_CAMLIDL_EXTERN_C yices_expr yices_mk_false(/*in*/ yices_context c);

_CAMLIDL_EXTERN_C yices_expr yices_mk_true(/*in*/ yices_context c);

_CAMLIDL_EXTERN_C yices_expr yices_mk_and(/*in*/ yices_context c, /*in*/ yices_expr *args, /*in*/ int n);

_CAMLIDL_EXTERN_C yices_expr yices_mk_or(/*in*/ yices_context c, /*in*/ yices_expr *args, /*in*/ int n);

_CAMLIDL_EXTERN_C yices_expr yices_mk_not(/*in*/ yices_context c, /*in*/ yices_expr a);

_CAMLIDL_EXTERN_C yices_expr yices_mk_app(/*in*/ yices_context c, /*in*/ yices_expr f, /*in*/ yices_expr *args, /*in*/ int n);

_CAMLIDL_EXTERN_C yices_expr yices_mk_sum(/*in*/ yices_context ctx, /*in*/ yices_expr *args, /*in*/ int n);

_CAMLIDL_EXTERN_C yices_expr yices_mk_sub(/*in*/ yices_context ctx, /*in*/ yices_expr *args, /*in*/ int n);

_CAMLIDL_EXTERN_C yices_expr yices_mk_mul(/*in*/ yices_context ctx, /*in*/ yices_expr *args, /*in*/ int n);

_CAMLIDL_EXTERN_C yices_expr yices_mk_num(/*in*/ yices_context ctx, /*in*/ int n);

_CAMLIDL_EXTERN_C yices_expr yices_mk_num_from_string(/*in*/ yices_context ctx, /*in*/ char *string);

_CAMLIDL_EXTERN_C yices_expr yices_mk_le(/*in*/ yices_context ctx, /*in*/ yices_expr a1, /*in*/ yices_expr a2);

_CAMLIDL_EXTERN_C int helper_get_int_value(/*in*/ yices_model m, /*in*/ yices_var_decl x);

_CAMLIDL_EXTERN_C int helper_get_value(/*in*/ yices_model m, /*in*/ yices_var_decl x);

_CAMLIDL_EXTERN_C int helper_get_num_value(/*in*/ yices_model m, /*in*/ yices_var_decl x);

_CAMLIDL_EXTERN_C int helper_get_dnum_value(/*in*/ yices_model m, /*in*/ yices_var_decl x);

_CAMLIDL_EXTERN_C void yices_enable_type_checker(/*in*/ int flag);

#ifdef _WIN32
#pragma pack(pop)
#endif


#endif /* !_CAMLIDL_YINTERFACE_H */
